<template>
  <div>
    <v-row>
      <v-col class="d-flex" cols="12" sm="6" md="3">
        <v-select
          v-model="searchedPrincipalCategory"
          :items="items"
          label="Categorias"
          v-on:change="ExecutFuncionalidadSelectPrincipalCategory()"
          dense
        ></v-select>
      </v-col>
    </v-row>
    <h1>Tiendas de Bilbao</h1>

    <span v-show="showMessage">No hay tiendas disponibles por esta catigoría</span>
    <v-row v-show="this.showTheGallery">
      <v-col
        cols="12"
        sm="6"
        md="3"
        class="shop-boxes"
        v-for="(shop, index) in shopList"
        :key="index"
      >
        <ShopBox class="shop-box" @go-to-this-shop-details="goToShopDetails" :shop="shop" />
      </v-col>
    </v-row>
  </div>
</template>

<script>
import ShopBox from "./ShopBox.vue";

import API from "@/API.js";
export default {
  name: "ShopListPage",
  components: {
    ShopBox
  },
  props: {},
  data() {
    return {
      shop_zone: this.$route.params.shop_zone,
      shopCategories: [],
      shopList: [],
      searchedPrincipalCategory: "principal-categorias",
      showTheGallery: true,
      items: [],
      showMessage: false
    };
  },
  async mounted() {
    await this.loadshopprincipalCategories();
    this.items = this.shopCategories.map(sweetItem => {
      return sweetItem["principal_category"];
    });
    console.log(this.$route.params.shop_zone);
    if (this.shop_zone !== undefined) {
      await this.loadThisZoneShopList(this.shop_zone);
    } else {
      await this.loadAllShopList();
    }
  },
  methods: {
    async loadAllShopList() {
      this.shopList = await API.loadAllShopList();
    },
    async loadThisZoneShopList(shop_zone) {
      this.shopList = await API.loadThisZoneShopList(shop_zone);
    },

    async loadshopprincipalCategories() {
      this.shopCategories = await API.loadshopprincipalCategories();
    },

    async ExecutFuncionalidadSelectPrincipalCategory() {
      this.showMessage = false;
      this.showTheGallery = true;
      if (this.searchedPrincipalCategory === "Todas ") {
        this.shopList = await API.loadAllShopList();
      } else {
        let searchedPrincipalCategory = this.searchedPrincipalCategory;
        await this.loadShopsFiltredByprincipalCategories(
          searchedPrincipalCategory
        );

        this.showGallery();
      }
    },
    async loadShopsFiltredByprincipalCategories(searchedPrincipalCategory) {
      this.shopList = await API.loadShopsFiltredByprincipalCategories(
        searchedPrincipalCategory
      );
    },
    goToShopDetails(searchedShop) {
      this.$router.push("/shop-Details/" + searchedShop);
    },
    showGallery() {
      if (this.shopList.length === 0) {
        this.showMessage = true;
      } else {
        this.showMessage = false;
      }
    }
  }
};
</script>
<style scoped>
.d-flex {
  margin-left: 9%;
}
</style>
